package com.god.data.common.domain;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * rabbitmq消息内容载体
 * @deprecated 消息内容载体，在rabbitmq中，存储的消息可以是任意的java类型的对象。
 * 强制要求，作为消息数据载体的类型，必须是Serializable的。
 * 如果消息数据载体类型未实现Serializable，在收发消息的时候，都会有异常发生。
 */
@Data
public class LogMessage implements Serializable {

    private Long id;
    private String msg;
    private String logLevel;
    private String serviceType;
    private Date createTime;
    private Long userId;
    private String exchange;

}
