package com.god.data.config;

import com.god.common.redis.service.RedisService;
import com.god.data.common.domain.ElePoint;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

import java.util.ArrayList;

/**
 * @description: 测试缓存
 * @Author fst
 * @date 2023/11/30 11:03
 */
@Configuration
public class RedisInitTest {
    @Autowired
    private RedisService redisService;



    public void redisInit()
    {
        redisService.deleteObject("Fence" + "VIN12345678912345");
        ArrayList<ElePoint> elePoints = new ArrayList<>();
        ElePoint e1 = ElePoint.builder().fenceLocation("116.357183,39.926512;116.394348,39.909989;116.34757,39.90617;").driveStatus(1).build();
        ElePoint e2 = ElePoint.builder().fenceLocation("116.36199,39.927921;116.411171,39.921207;116.378126,39.900798;").driveStatus(2).build();
        ElePoint e3 = ElePoint.builder().fenceLocation("116.357133,39.927258;116.391552,39.90685;116.358078,39.906587;116.345718,39.922387;").driveStatus(1).build();
        elePoints.add(e1);
        elePoints.add(e2);
        elePoints.add(e3);
        redisService.setCacheList("Fence" + "VIN12345678912345", elePoints);
    }


    public void parseInit()
    {
        redisService.deleteObject("event" + "VIN12345678912345");
        ArrayList<String> strings = new ArrayList<>();
        // strings.add("fence");
        strings.add("FaultAlarm");
        strings.add("RealTimeTrajectory");
        redisService.setCacheList("event" + "VIN12345678912345", strings);
    }
}
