package com.god.data.test;

import com.god.common.redis.service.RedisService;
import com.god.data.common.domain.CarMessage;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * Description:
 *
 * @Author: sun-cool-boy
 * @Date: 2023/12/1
 * @info:
 */
@SpringBootTest
public class SJZTest {
    /**
     * 实时轨迹存储
     */
    public static final String ALL_LOCUS_INFO = "all_locus_info";
    /**
     * 实时轨迹标识
     */
    public static final String LOCUS = "locus";

    @Autowired
    private RedisService redisService;
    @Test
    public void testRedis(){
        ArrayList<BigDecimal> bigDecimals = new ArrayList<>();
        bigDecimals.add(BigDecimal.valueOf(12.222));
        bigDecimals.add(BigDecimal.valueOf(35.232));
        ArrayList<ArrayList<BigDecimal>> arrayLists = new ArrayList<>();
        arrayLists.add(bigDecimals);
        HashMap<String, ArrayList<ArrayList<BigDecimal>>> map = new HashMap<>();
        map.put("vim",arrayLists);
        redisService.setCacheMap("123",map);

        Map<String, Object> cacheMap = redisService.getCacheMap("123");
        cacheMap.forEach((key,value)->{
            System.out.println(key + "  " +value);
        });

    }

    @Test
    public void test2(){
        CarMessage one = CarMessage.builder()
                .vin("vin5211314")
                .longitude(BigDecimal.valueOf(22.4512439))
                .latitude(BigDecimal.valueOf(23.49785))
                .build();

        CarMessage two = CarMessage.builder()
                .vin("vin5211314")
                .longitude(BigDecimal.valueOf(44.91230))
                .latitude(BigDecimal.valueOf(55.45456))
                .build();

        CarMessage three = CarMessage.builder()
                .vin("vin5211314")
                .longitude(BigDecimal.valueOf(29.41235))
                .latitude(BigDecimal.valueOf(36.41235))
                .build();

        ArrayList<CarMessage> list = new ArrayList<>();
        list.add(one);
        list.add(two);
        list.add(three);
        for (CarMessage carMessage : list) {
            //新建一个用于存经纬度的集合 保存精度和维度
            ArrayList<BigDecimal> bigDecimals = new ArrayList<>();
            bigDecimals.add(carMessage.getLongitude());
            bigDecimals.add(carMessage.getLatitude());
            if (redisService.hasKey(ALL_LOCUS_INFO)){//vin轨迹的键存在
                //获取键 对应的 值
                Map<String, Object> cacheMap = redisService.getCacheMap(ALL_LOCUS_INFO);
                //前端需要格式  [ [..] , [..] ] 所以需要再次新建一个集合来存之前的集合
                ArrayList<ArrayList<BigDecimal>> orDefault = (ArrayList<ArrayList<BigDecimal>>) cacheMap.getOrDefault(carMessage.getVin(), new ArrayList<ArrayList<BigDecimal>>());
                addLocusRedisInfo(cacheMap,
                        orDefault,
                        bigDecimals,
                        carMessage.getVin());
            }else {
                //代表当前vin没有实时轨迹相关数据 直接新建集合存储即可
                addLocusRedisInfo(new HashMap<>(),
                        new ArrayList<>(),
                        bigDecimals,
                        carMessage.getVin());
            }

        }
    }
    private void addLocusRedisInfo(Map<String, Object> map,
                                   ArrayList<ArrayList<BigDecimal>> lists,
                                   ArrayList<BigDecimal> list,
                                   String vin) {
        lists.add(list);
        map.put(vin,lists);
        redisService.setCacheMap(ALL_LOCUS_INFO,map);
    }

    @Test
    public void testThree(){
        Map<String, Object> cacheMap = redisService.getCacheMap(ALL_LOCUS_INFO);
        ArrayList<ArrayList<BigDecimal>> orDefault = (ArrayList<ArrayList<BigDecimal>>) cacheMap.getOrDefault("vin123123123", new ArrayList<ArrayList<BigDecimal>>());
        ArrayList<BigDecimal> bigDecimals = orDefault.get(orDefault.size() - 1);
        bigDecimals.forEach(obj -> {
            System.out.println(obj);
        });
    }

}
