package com.god.data.utils;

import com.god.data.common.domain.CarMessage;

import java.math.BigDecimal;

/**
 * 报文解析工具类
 * @description: 报文解析工具类
 * @Author fst
 * @date 2023/11/23 14:30
 */
public class AnalyzeUtils {

    /**
     * 解析报文获取报文对象
     */
    public static CarMessage parseVehicleData(String input) {
        System.out.println(input);
        //把数据处理成java对象，返回解析完的对象.
        return CarMessage.builder()
                .vin(input.substring(1, 18))
                .timeString(Long.valueOf(input.substring(18, 31)))
                .longitude(BigDecimal.valueOf(Double.parseDouble(input.substring(31, 42))))
                .latitude(BigDecimal.valueOf(Double.parseDouble(input.substring(42, 52))))
                .speed(BigDecimal.valueOf(Double.parseDouble(input.substring(52, 58))))
                .sumMileage(BigDecimal.valueOf(Double.parseDouble(input.substring(58, 69))))
                .sumVoltage(BigDecimal.valueOf(Double.parseDouble(input.substring(69, 75))))
                .sumElectricity(BigDecimal.valueOf(Double.parseDouble(input.substring(75, 80))))
                .sumResistance(BigDecimal.valueOf(Double.parseDouble(input.substring(80, 89))))
                .gear(input.substring(89, 90))
                .acceleratorPedal(BigDecimal.valueOf(Double.parseDouble(input.substring(90, 91))))
                .brakePedal(BigDecimal.valueOf(Double.parseDouble(input.substring(91, 93))))
                .specificFuelConsumption(BigDecimal.valueOf(Double.parseDouble(input.substring(93, 98))))
                .motorControllerTemperature(BigDecimal.valueOf(Double.parseDouble(input.substring(98, 104))))
                .motorSpeed(Long.valueOf(input.substring(104, 109)))
                .motorTorque(Long.valueOf(input.substring(109, 113)))
                .motorTemperature(BigDecimal.valueOf(Double.parseDouble(input.substring(113, 119))))
                .motorTage(BigDecimal.valueOf(Double.parseDouble(input.substring(119, 124))))
                .motorCurrent(BigDecimal.valueOf(Double.parseDouble(input.substring(124, 132))))
                .remainingBattery(BigDecimal.valueOf(Double.parseDouble(input.substring(132, 138))))
                .maximumFeedbackPower(BigDecimal.valueOf(Double.parseDouble(input.substring(138, 144))))
                .maximumDischargePower(BigDecimal.valueOf(Double.parseDouble(input.substring(144, 150))))
                .selfCheckCounter(Integer.valueOf(input.substring(150, 152)))
                .totalBatteryCurrent(BigDecimal.valueOf(Double.parseDouble(input.substring(152, 157))))
                .totalBatteryVoltage(BigDecimal.valueOf(Double.parseDouble(input.substring(157, 163))))
                .singleBatteryMaxVoltage(BigDecimal.valueOf(Double.parseDouble(input.substring(163, 167))))
                .singleBatteryMinVoltage(BigDecimal.valueOf(Double.parseDouble(input.substring(167, 171))))
                .singleBatteryMaxTemperature(BigDecimal.valueOf(Double.parseDouble(input.substring(171, 177))))
                .singleBatteryMinTemperature(BigDecimal.valueOf(Double.parseDouble(input.substring(177, 183))))
                .availableBatteryCapacity(BigDecimal.valueOf(Double.parseDouble(input.substring(183, 189))))
                .vehicleStatus(Integer.valueOf(input.substring(189, 190)))
                .chargingStatus(Integer.valueOf(input.substring(190, 191)))
                .operatingStatus(Integer.valueOf(input.substring(191, 192)))
                .socStatus(Integer.valueOf(input.substring(192, 193)))
                .chargingEnergyStorageStatus(Integer.valueOf(input.substring(193, 194)))
                .driveMotorStatus(Integer.valueOf(input.substring(194, 195)))
                .positionStatus(Integer.valueOf(input.substring(195, 196)))
                .easStatus(Integer.valueOf(input.substring(196, 197)))
                .ptcStatus(Integer.valueOf(input.substring(197, 198)))
                .epsStatus(Integer.valueOf(input.substring(198, 199)))
                .absStatus(Integer.valueOf(input.substring(199, 200)))
                .mcuStatus(Integer.valueOf(input.substring(200, 201)))
                .heatingStatus(Integer.valueOf(input.substring(201, 202)))
                .batteryStatus(Integer.valueOf(input.substring(202, 203)))
                .batteryInsulationStatus(Integer.valueOf(input.substring(203, 204)))
                .dcdcStatus(Integer.valueOf(input.substring(204, 205)))
                .chgStatus(Integer.valueOf(input.substring(205, 206)))
                .build();

    }

    public static void main(String[] args) {
        CarMessage carMessage = parseVehicleData(
                "~VIN123456789123451701309761024116." +
                        "670799039.536898072.00012.9400000016000" +
                        "028000879100000D707011.6047000060152600011900024000" +
                        "7960000044970.230000310000601000023500030003000" +
                        "47000026000025000011111111111111111Í~");
        System.out.println(carMessage);
    }







}
